Package: cfTools
Type: Package
Title: Informatics Tools for Cell-Free DNA Study
Version: 1.13.0
Authors@R: c(
    person(given = "Ran",
        family = "Hu",
        role = c("aut", "cre"),
        email = "huran@ucla.edu",
        comment = c(ORCID = "0000-0002-0563-8957")),
    person(c("Mary", "Louisa"), "Stackpole", 
        role = "aut",
        comment = c(ORCID = "0000-0003-4432-6718")),
    person("Shuo", "Li", 
        role = "aut",
        comment = c(ORCID = "0000-0002-1960-6016")),
    person(c("Xianghong", "Jasmine"), "Zhou", 
        role = "aut", 
        email = "XJZhou@mednet.ucla.edu", 
        comment = c(ORCID = "0000-0002-4522-7490")),
    person("Wenyuan", "Li", 
        role = "aut",
        email = "WenyuanLi@mednet.ucla.edu",
        comment = c(ORCID = "0000-0002-5029-8525")))
Description: The cfTools R package provides methods for cell-free DNA (cfDNA) 
    methylation data analysis to facilitate cfDNA-based studies. Given the 
    methylation sequencing data of a cfDNA sample, for each cancer marker 
    or tissue marker, we deconvolve the tumor-derived or tissue-specific reads 
    from all reads falling in the marker region. Our read-based deconvolution 
    algorithm exploits the pervasiveness of DNA methylation for signal enhancement, 
    therefore can sensitively identify a trace amount of tumor-specific or 
    tissue-specific cfDNA in plasma. cfTools provides functions for 
    (1) cancer detection: sensitively detect tumor-derived cfDNA and estimate 
    the tumor-derived cfDNA fraction (tumor burden); (2) tissue deconvolution: 
    infer the tissue type composition and the cfDNA fraction of multiple tissue 
    types for a plasma cfDNA sample. These functions can serve as foundations 
    for more advanced cfDNA-based studies, including cancer diagnosis and 
    disease monitoring.
License: file LICENSE
Encoding: UTF-8
Suggests: BiocStyle, knitr, rmarkdown, testthat (>= 3.0.0)
Config/testthat/edition: 3
RoxygenNote: 7.2.3
Imports: Rcpp, utils, GenomicRanges, basilisk, R.utils, stats,
        cfToolsData, grDevices, graphics
StagedInstall: no
biocViews: Software, BiomedicalInformatics, Epigenetics, Sequencing,
        MethylSeq, DNAMethylation, DifferentialMethylation
VignetteBuilder: knitr
LinkingTo: Rcpp, BH
URL: https://github.com/jasminezhoulab/cfTools
BugReports: https://github.com/jasminezhoulab/cfTools/issues
Config/Bioconductor/UnsupportedPlatforms: windows-x86
git_url: https://git.bioconductor.org/packages/cfTools
git_branch: devel
git_last_commit: 0441752
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: yes
Packaged: 2026-04-29 20:54:07 UTC; biocbuild
Author: Ran Hu [aut, cre] (ORCID: <https://orcid.org/0000-0002-0563-8957>),
  Mary Louisa Stackpole [aut] (ORCID:
    <https://orcid.org/0000-0003-4432-6718>),
  Shuo Li [aut] (ORCID: <https://orcid.org/0000-0002-1960-6016>),
  Xianghong Jasmine Zhou [aut] (ORCID:
    <https://orcid.org/0000-0002-4522-7490>),
  Wenyuan Li [aut] (ORCID: <https://orcid.org/0000-0002-5029-8525>)
Maintainer: Ran Hu <huran@ucla.edu>

# cfTools: an R/Bioconductor package for deconvolving cell-free DNA via methylation analysis

We developed the R/Bioconductor package cfTools to deconvolve cfDNA from diseased or normal tissues using DNA methylation profiles. cfTools offers a streamlined workflow for sensitive cancer detection and tissue deconvolution, which can be applied in a broad range of clinical applications involving cfDNA-based diagnosis, prognosis and disease monitoring for cancer and other conditions.

![workflow](./workflow.png)

## Introduction

cfTools is an R/Bioconductor package that provides a seamless workflow from standard Bismark-processed files to downstream deconvolution functions that decipher cfDNA tissue-of-origin based on methylation profiles. Through the analysis of methylation patterns of tumor or tissue reference markers at the individual DNA fragment level, cfTools calculates the proportions of cfDNA fragments derived from tumor or normal tissues, thereby informing the global tissue composition of plasma cfDNA. 

To distinguish tumor-derived cfDNA from background fragments and estimate tumor burden, it provides the `CancerDetector` function. To deconvolve multiple tissue types and quantify the tissue composition of cfDNA, it provides two functions. One is `cfDeconvolve`, which is an unsupervised probabilistic approach that can incorporate any user-defined methylation markers and various types of methylation data. The other function is `cfSort`, a supervised deep learning-based pretrained model designed to work with predetermined methylation markers of 29 tissue types and cfDNA methylome sequencing data, such as Whole Genome Bisulfite Sequencing (WGBS) and cfDNA Methylome Sequencing (cfMethyl-Seq) data. While the supervised method offers enhanced accuracy with predefined markers, the unsupervised method provides greater flexibility by accommodating user-specified markers and an unknown tissue type but may not achieve the same level of precision. In addition, to facilitate the use of cfTools, we created the cfToolsData package that offers users access to reference marker files, which encompasses DNA methylation marker information for four cancer types (colon, liver, lung, and stomach cancer) and 29 primary human tissue types. Featuring user-customizable options, cfTools and cfToolsData facilitate the straightforward extraction of biologically meaningful information from standard preprocessed sequencing data, accommodating a wide range of clinical applications such as disease diagnosis, prognosis, and monitoring.

## Installation

`cfTools` is an `R` package available via the [Bioconductor](http://bioconductor.org) repository for packages. You can install the release version by using the following commands in your `R` session:

```
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}
BiocManager::install("cfTools")
```

Alternatively, you can install the development version from [GitHub](https://github.com/) :

```
BiocManager::install("jasminezhoulab/cfTools")
```

## Documentation

See the detailed documentation for `cfTools` using the following commands in your `R` session
```
browseVignettes("cfTools")
```

## Citation

If you use `cfTools` in your research, please cite the following paper:
> Hu, R., Li, S., Stackpole, M. L., Li, Q., Zhou, X. J., & Li, W. (2025). cfTools: an R/Bioconductor package for deconvolving cell-free DNA via methylation analysis. *Bioinformatics Advances*, vbaf108. https://doi.org/10.1093/bioadv/vbaf108

#' Methylation information for CpG on the original top strand (OT)
#'
#' Methylation information for CpG on the original 
#' top strand (OT), which is one of the outputs from 
#' 'bismark methylation extractor'
#'
#' @name CpG_OT_demo
#' 
#' @return A tibble with 2556 rows and 5 variables
#' 
#' @format A tibble with 2556 rows and 5 variables
#' \describe{
#' \item{sequence ID}{ID of the sequence}
#' \item{methylation state}{Methylated or unmethylated CpG site}
#' \item{chromosome name}{Chromosome name}
#' \item{chromosome start}{Chromosome start position}
#' \item{methylation call}{Methylation call}
#' }
#' @usage data("CpG_OT_demo")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

my_env <- BasiliskEnvironment(envname="new_env",
                              pkgname="cfTools",
                              packages=c("python==3.8",
                                         "numpy==1.23.4", 
                                         "scipy==1.8.0",
                                         "tensorflow==2.10.0")
                              )

#' Genomic postions of markers
#'
#' A BED file of genomic regions of markers
#'
#' @name markers.bed
#' 
#' @return A tibble with 3 rows and 4 variables
#' 
#' @format A tibble with 3 rows and 4 variables
#' \describe{
#' \item{chr}{Chromosome}
#' \item{start}{Chromosome start}
#' \item{end}{Chromosome end}
#' \item{markerName}{Marker name}
#' }
#' @usage data("markers.bed")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' @title
#' Cancer Detector
#'
#' @description
#' Detect tumor-derived cfDNA and estimate the tumor burden.
#'
#' @param readsBinningFile a file of the fragment-level methylation states 
#' of reads that mapped to the markers.
#' @param tissueMarkersFile a file of paired shape parameters of beta 
#' distributions for markers.
#' @param lambda a number controlling "confounding" markers' distance 
#' from average markers.
#' @param id the sample ID.
#'
#' @return a list containing the cfDNA tumor burden 
#' and the normal cfDNA fraction.
#'
#' @examples
#' ## input files
#' demo.dir <- system.file("data", package="cfTools")
#' readsBinningFile <- file.path(demo.dir, "CancerDetector.reads.txt.gz")
#' tissueMarkersFile <- file.path(demo.dir, "CancerDetector.markers.txt.gz")
#' lambda <- 0.5
#' id <- "test"
#'
#' CancerDetector(readsBinningFile, tissueMarkersFile, lambda, id)
#'
#' @export
CancerDetector <- function(readsBinningFile, tissueMarkersFile, 
                           lambda = 0.5, id = "sample") {

    python.script.dir <- system.file("python", package = "cfTools", 
                                    mustWork = TRUE)
    
    extdata.dir <- system.file("data", package = "cfTools", mustWork = TRUE)
    output.dir <- extdata.dir
    
    timeNow <- strsplit(strsplit(as.character(Sys.time()), 
                        " ")[[1]][2], ":")[[1]]
    id <- paste0(id, timeNow[1], timeNow[2], timeNow[3])
    
    # output.dir <- paste0(extdata.dir, "/tmp/")
    # if (system.file("extdata/tmp", package = "cfTools") == "") {
    #   system2(command = "mkdir", args = output.dir)
    # }
    # id <- strsplit(as.character(Sys.time()), " ")[[1]][2]

    py1 <- paste0(python.script.dir, "/CalcReadLikelihood.py")
    py1.command <- c(py1, readsBinningFile, tissueMarkersFile, 
                         output.dir, id)
    
    id.likelihood <- file.path(output.dir, paste0(id, ".likelihood.txt"))
    tumor.burden <- file.path(output.dir, paste0(id, ".tumor_burden.txt"))
    
    py2 <- paste0(python.script.dir, "/CancerDetector.py")
    py2.command <- c(py2, id.likelihood, lambda, output.dir, id)
    
    proc <- basiliskStart(my_env)
    
    basiliskRun(proc, function() {
        system2(command = "python", args = py1.command)
        system2(command = "python", args = py2.command)
    })
    basiliskStop(proc)
    
    tumor_burden <- read.csv(tumor.burden, header = FALSE, sep = "\t")
    file.remove(id.likelihood)
    file.remove(tumor.burden)
    
    # cat(paste("cfDNA tumor burden:", tumor_burden$V1, "\n"))
    # cat(paste("normal cfDNA fraction:", tumor_burden$V2))
    colnames(tumor_burden) <- c("cfDNA_tumor_burden", 
                                "normal_cfDNA_fraction")
    
    return(tumor_burden)
    # system2(command = "rm", args = id.likelihood)
    # system2(command = "rm", args = tumor.burden)
}

test_that("CancerDetector() works", {

    demo.dir <- system.file("data", package="cfTools")
    readsBinningFile <- file.path(demo.dir, "CancerDetector.reads.txt.gz")
    tissueMarkersFile <- file.path(demo.dir, "CancerDetector.markers.txt.gz")
    
    result_CancerDetector <- CancerDetector(readsBinningFile, 
                                            tissueMarkersFile)
    
    expect_equal(result_CancerDetector$cfDNA_tumor_burden, 0.055)
    expect_equal(result_CancerDetector$normal_cfDNA_fraction, 0.945)
})

#' @title
#' Plot Pie Chart
#'
#' @description
#' Generate a pie chart for a vector of class fractions (e.g., tissue 
#' composition or cfDNA fractions). Automatically filters small values 
#' into an "Other" group, and allows for custom colors and font size control.
#'
#' @param fraction_vector a named numeric vector or one-row data.frame, 
#' where each value represents a class proportion.
#' @param title the title of the plot.
#' @param threshold a numeric value. Classes with fraction values below this 
#' threshold will be grouped into "Other".
#' @param class_colors a named character vector assigning colors to specific 
#' class names (e.g., c("tumor" = "red")).
#' @param font_size numeric, font scaling factor (default is 1.0).
#'
#' @return A pie chart is plotted to the current device.
#'
#' @examples
#' df <- data.frame(
#'   WBC = 0.93,
#'   Liver = 0.04,
#'   Lung = 0.02,
#'   Muscle = 1.2345e-4,
#'   Stomach = 9.87655e-03
#' )
#' PlotFractionPie(df, title = "cfDNA Composition", font_size = 1.2)
#'
#' @export
PlotFractionPie <- function(fraction_vector,
                              title = "Composition",
                              threshold = 0.01,
                              class_colors = NULL,
                              font_size = 1.0) {
    # Convert one-row data frame to named numeric vector
    if (is.data.frame(fraction_vector) && nrow(fraction_vector) == 1) {
        class_names <- colnames(fraction_vector)
        fraction_vector <- as.numeric(fraction_vector)
        names(fraction_vector) <- class_names
    }
    
    # Sort and filter
    fraction_vector <- sort(fraction_vector, decreasing = TRUE)
    is_other <- fraction_vector < threshold
    other_components <- fraction_vector[is_other]
    filtered <- fraction_vector[!is_other]
    
    if (length(other_components) > 0) {
        filtered <- c(filtered, Other = sum(other_components))
    }
    
    # Percentages
    percent <- filtered * 100
    slice_labels <- paste0(round(percent, 2), "%")
    
    # Format percentages for legend
    format_percent <- function(x) {
        if (x >= 0.001) {
            paste0(format(round(x, 3), nsmall = 3), "%")
        } else {
            paste0(formatC(x, format = "e", digits = 3), "%")
        }
    }
    
    # Legend labels
    legend_labels <- paste0(names(filtered), " (", vapply(percent, format_percent, character(1)), ")")
    
    if ("Other" %in% names(filtered)) {
        other_percents <- other_components * 100
        other_breakdown <- paste0(
            "   - ", names(other_components),
            " (", vapply(other_percents, format_percent, character(1)), ")"
        )
        legend_labels <- append(legend_labels, c("Other includes:", other_breakdown),
                                after = which(names(filtered) == "Other"))
    }
    
    # Assign colors
    all_class_names <- names(filtered)
    default_colors <- rainbow(length(filtered))
    colors <- setNames(default_colors, all_class_names)
    
    if (!is.null(class_colors)) {
        matched <- intersect(names(class_colors), names(filtered))
        colors[matched] <- class_colors[matched]
    }
    
    # Layout and margins — bring title and legend closer
    old_par <- par(no.readonly = TRUE)
    on.exit(par(old_par))
    
    # Adjust layout: smaller gap between pie and legend
    layout(matrix(1:2, nrow = 1), widths = c(2, 1.5))
    
    # Pie margins: reduce top margin to bring title closer
    par(mar = c(2, 1, 2, 1))  # bottom, left, top, right
    
    pie(filtered,
        labels = slice_labels,
        col = colors,
        main = title,
        cex.main = font_size * 1.2,
        cex = font_size)
    
    # Legend margins: shrink all sides slightly
    par(mar = c(1, 0, 2, 1))  # less padding for legend area
    plot.new()
    legend("left",
           legend = legend_labels,
           fill = c(colors, rep(NA, length(legend_labels) - length(colors))),
           border = NA,
           bty = "n",
           cex = font_size * 0.9,
           x.intersp = 0.5,
           y.intersp = 0.9)  # slightly reduce vertical spacing
}

#' Marker name
#'
#' A vector of marker names corresponding to the columns 
#' of the list of methylation levels.
#'
#' @name marker_index
#' 
#' @return A tibble with 3 rows and 1 variables
#' 
#' @format A tibble with 3 rows and 1 variables
#' \describe{
#' \item{markerIndex}{Marker name}
#' }
#' @usage data("marker_index")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' Tissue-specific marker parameter
#'
#' The paired shape parameters of beta distributions 
#' for tissue-specific markers
#'
#' @name cfDeconvolve.markers
#' 
#' @return A tibble with 10 rows and 8 variables
#' 
#' @format A tibble with 10 rows and 8 variables
#' \describe{
#' \item{markerName}{Name of the marker}
#' \item{tissue1}{Paired beta distribution shape parameters 
#' for tissue1 samples}
#' \item{tissue2}{Paired beta distribution shape parameters 
#' for tissue2 samples}
#' \item{tissue3}{Paired beta distribution shape parameters 
#' for tissue3 samples}
#' \item{tissue4}{Paired beta distribution shape parameters 
#' for tissue4 samples}
#' \item{tissue5}{Paired beta distribution shape parameters 
#' for tissue5 samples}
#' \item{tissue6}{Paired beta distribution shape parameters 
#' for tissue6 samples}
#' \item{tissue7}{Paired beta distribution shape parameters 
#' for tissue7 samples}
#' }
#' @usage data("cfDeconvolve.markers")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' Sample type
#'
#' A vector of sample types (e.g., tumor or normal, 
#' tissue types) corresponding to the rows of the 
#' list of methylation levels.
#'
#' @name sample_type
#' 
#' @return A tibble with 20 rows and 1 variables
#' 
#' @format A tibble with 20 rows and 1 variables
#' \describe{
#' \item{sampleType}{Sample type}
#' }
#' @usage data("sample_type")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

paraEstMoM <- function(meths) {
    mu <- mean(meths,na.rm = TRUE)
    variant <- var(meths,na.rm = TRUE)
    mu[mu == 0] <- 1e-5
    mu[mu == 1] <- 1-1e-5
    variant[variant == 0] <- 1e-9
    momAlpha <- round(-mu*(variant+mu*mu-mu)/variant, digits = 3)
    momBeta <- round((mu-1)*(variant+mu*mu-mu)/variant, digits = 3)
    return(c('shape1'=momAlpha, 'shape2'=momBeta))
}

#' @title
#' Generate the methylation pattern of markers
#'
#' @description
#' Output paired shape parameters of beta distributions for methylation markers.
#'
#' @param x a list of methylation levels (e.g., beta values), 
#' where each row is a sample and each column is a marker.
#' @param sample.types a vector of sample types (e.g., tumor or normal, 
#' tissue types) corresponding to the rows of the list.
#' @param marker.names a vector of marker names corresponding to the 
#' columns of the list.
#' @param output.file a character string naming the output file. 
#' Default is "", which means the output will not be written into a file.
#' 
#' @return a list containing the paired shape parameters of 
#' beta distributions for markers and/or written to an output file.
#' 
#' @examples
#' ## input files
#' demo.dir <- system.file("data", package="cfTools")
#' methLevel <- read.table(file.path(demo.dir, "beta_matrix.txt.gz"), 
#' row.names=1, header = TRUE)
#' sampleTypes <- read.table(file.path(demo.dir, "sample_type.txt.gz"), 
#' row.names=1, header = TRUE)$sampleType
#' markerNames <- read.table(file.path(demo.dir, "marker_index.txt.gz"), 
#' row.names=1, header = TRUE)$markerIndex
#'
#' output <- GenerateMarkerParam(methLevel, sampleTypes, markerNames)
#' 
#' @export
GenerateMarkerParam <- function(x, sample.types, marker.names, 
                                output.file="") {

    colnames(x) <- marker.names
    typeTrain <- split(x, sample.types) #split based on sample types
    
    typePara <- list()
    all_types <- names(typeTrain)
    ordered_types <- c(
        all_types[grepl("tumor", all_types, ignore.case = TRUE)],
        all_types[!grepl("tumor", all_types, ignore.case = TRUE)]
    )
    
    for (type in ordered_types) {
        typePara[[type]] <- do.call('cbind', lapply(as.list(typeTrain[[type]]), 
                                    paraEstMoM))
    }
    
    alphas_betas <- do.call(cbind, lapply(typePara, 
                            function(x) paste0(x[1,], ":", x[2,])))
    alphas_betas_index <- as.data.frame(cbind(marker.names, alphas_betas))
    colnames(alphas_betas_index) <- c("markerName", colnames(alphas_betas))
    
    if (output.file != "") {
        write.table(alphas_betas_index, output.file, sep='\t', row.names=FALSE, 
                    col.names=TRUE, quote=FALSE)
    }
    
    return(alphas_betas_index)
}

#' Beta value matrix
#'
#' A list of methylation levels (e.g., beta values), 
#' where each row is a sample and each column is a marker
#'
#' @name beta_matrix
#' 
#' @return A tibble with 20 rows and 3 variables
#' 
#' @format A tibble with 20 rows and 3 variables
#' \describe{
#' \item{marker1}{Beta values of marker1 for all samples}
#' \item{marker2}{Beta values of marker2 for all samples}
#' \item{marker3}{Beta values of marker3 for all samples}
#' }
#' @usage data("beta_matrix")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' @useDynLib cfTools, .registration = TRUE
NULL
#' @importFrom Rcpp sourceCpp
NULL
#' @importFrom Rcpp evalCpp
NULL
#' @import Rcpp
NULL
#' @importFrom utils read.csv write.table read.delim
NULL
#' @import GenomicRanges
NULL
#' @importFrom basilisk basiliskRun BasiliskEnvironment
NULL
#' @importFrom basilisk basiliskStart basiliskStop
NULL
#' @importFrom R.utils gunzip
NULL
#' @importFrom utils read.table
NULL
#' @importFrom stats var setNames
NULL
#' @importFrom cfToolsData DNN1 DNN2
NULL
#' @importFrom graphics layout legend par pie plot.new
NULL
#' @importFrom grDevices rainbow
NULL

#' @title
#' Generate fragment-level information for paired-end sequencing reads
#'
#' @description
#' Merge BED file (the output of `bedtools bamtobed`) to 
#' fragment-level for paired-end sequencing reads.
#'
#' @param bed_file a (sorted) BED file of paired-end reads.
#' @param output.dir a path to the output directory. Default is "", 
#' which means the output will not be written into a file.
#' @param id an ID name for the input data. Default is "", 
#' which means the output will not be written into a file.
#' 
#' @return a list in BED file format and/or written to 
#' an output BED file.
#'
#' @examples
#' ## input files
#' demo.dir <- system.file("data", package="cfTools")
#' PEReads <- file.path(demo.dir, "demo.sorted.bed.txt.gz")
#'
#' output <- MergePEReads(PEReads)
#'
#' @export
MergePEReads <- function(bed_file, output.dir="", id="") {

    python.script.dir <- system.file("python", package = "cfTools", 
                                    mustWork = TRUE)
    hasOutput <- TRUE
    
    if (output.dir=="" | id=="") {
        hasOutput <- FALSE
        extdata.dir <- system.file("data", package = "cfTools", 
                                    mustWork = TRUE)
        output.dir <- extdata.dir
        
        timeNow <- strsplit(strsplit(as.character(Sys.time()), 
                                    " ")[[1]][2], ":")[[1]]
        id <- paste0(timeNow[1], timeNow[2], timeNow[3])
        
        # output.dir <- paste0(extdata.dir, "/tmp/")
        # if (system.file("extdata/tmp", package = "cfTools") == "") {
        #   system2(command = "mkdir", args = output.dir)
        # }
        # id <- strsplit(as.character(Sys.time()), " ")[[1]][2]
    }
    
    py1 <- paste0(python.script.dir, "/collapse_bed_file_strand_correct.py")
    refo_frag <- file.path(output.dir, paste0(id, ".refo_frag.bed"))
    py1.command <- c(py1, bed_file, refo_frag)
    
    proc <- basiliskStart(my_env)
    
    basiliskRun(proc, function() {
        system2(command = "python", args = py1.command)
    })
    basiliskStop(proc)
    
    output_bed <- read.csv(refo_frag, sep="\t", header = FALSE)
    output_bed <- as.data.frame(output_bed[order(output_bed$V6),])
    rownames(output_bed) <- NULL
    colnames(output_bed) <- c("chr", "start", "end", "fragmentLength", 
                                "strand", "qname")
    
    write.table(output_bed, refo_frag, sep="\t", row.names=FALSE, 
                col.names=TRUE, quote=FALSE)
    if (!hasOutput) {
        # system2(command = "rm", args = refo_frag)
        file.remove(refo_frag)
    }
    
    return(output_bed)
}

test_that("MergeCpGs() works", {
  
  demo.dir <- system.file("data", package="cfTools")
  PEReads <- file.path(demo.dir, "demo.sorted.bed.txt.gz")
  
  result_MergePEReads <- MergePEReads(PEReads)
  
  expect_type(result_MergePEReads, "list")
})

#' @title
#' Generate fragment-level information about methylation states
#'
#' @description
#' Join two lists containing the fragment information and the 
#' methylation states on each fragment into one list.
#'
#' @param frag_bed a BED file containing information for every fragment, 
#' which is the output of MergePEReads().
#' @param meth_bed a BED file containing methylation states on every fragment, 
#' which is the output of MergeCpGs().
#' @param output.dir a path to the output directory. Default is "", 
#' which means the output will not be written into a file.
#' @param id an ID name for the input data. Default is "", 
#' which means the output will not be written into a file.
#' 
#' @return a list in BED file format and/or written to 
#' an output BED file.
#'
#' @examples
#' ## input files
#' demo.dir <- system.file("data", package="cfTools")
#' frag_bed <- read.delim(file.path(demo.dir, "demo.refo_frag.bed.txt.gz"), 
#' colClasses = "character")
#' meth_bed <- read.delim(file.path(demo.dir, "demo.refo_meth.bed.txt.gz"), 
#' colClasses = "character")
#'
#' output <- GenerateFragMeth(frag_bed, meth_bed)
#'
#' @export
GenerateFragMeth <- function(frag_bed, meth_bed, output.dir="", 
                            id="") {

    # python.script.dir <- system.file("python", package = "cfTools", 
    #                                 mustWork = TRUE)
    hasOutput <- TRUE
    
    if (output.dir=="" | id=="") {
        hasOutput <- FALSE
        extdata.dir <- system.file("data", package = "cfTools", 
                                    mustWork = TRUE)
        output.dir <- extdata.dir
        
        timeNow <- strsplit(strsplit(as.character(Sys.time()), 
                                    " ")[[1]][2], ":")[[1]]
        id <- paste0(timeNow[1], timeNow[2], timeNow[3])
        
        # output.dir <- paste0(extdata.dir, "/tmp")
        # if (system.file("extdata/tmp", package = "cfTools") == "") {
        #   system2(command = "mkdir", args = output.dir)
        # }
    }
    
    fragment_level.meth <- file.path(output.dir, 
                                    paste0(id, ".fragment_level.meth.bed"))

    merged_file <- merge(x=frag_bed, y=meth_bed, by = "qname")
    output_bed <- as.data.frame(cbind(merged_file$chr.x, merged_file$start, 
                                merged_file$end, merged_file$qname, 
                                merged_file$fragmentLength, 
                                merged_file$strand.x, merged_file$cpgNumber,
                                merged_file$cpgPosition, 
                                merged_file$methState))
    colnames(output_bed) <- c("chr", "start", "end", "qname", "fragmentLength", 
                            "strand", "cpgNumber", "cpgPosition", "methState")
    
    output_bed <- output_bed[with(output_bed, 
                                order(chr, start)), ] #sort by chr and start
    rownames(output_bed) <- NULL
    
    write.table(output_bed, fragment_level.meth, sep="\t", row.names=FALSE, 
                col.names=TRUE, quote=FALSE)
    if (!hasOutput) {
        # system2(command = "rm", args = fragment_level.meth)
        file.remove(fragment_level.meth)
    }
    
    return(output_bed)
}

#' Methylation information on fragments
#'
#' A BED file of methylation information on fragments
#'
#' @name demo.refo_meth.bed
#' 
#' @return A tibble with 552 rows and 8 variables
#' 
#' @format A tibble with 552 rows and 8 variables
#' \describe{
#' \item{chr}{Chromosome}
#' \item{cpgStart}{Start postion of first CpG on the fragment}
#' \item{cpgEnd}{End postion of first CpG on the fragment}
#' \item{strand}{Strand}
#' \item{cpgNumber}{Number of CpG sites on the fragment}
#' \item{cpgPosition}{Postions of CpG sites on the fragment}
#' \item{methState}{A string of methylation states of 
#' CpG sites on the fragment}
#' \item{name}{ID of the sequence}
#' }
#' @usage data("demo.refo_meth.bed")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' cfTools: a versatile package for analyzing cell-free DNA data
#' 
#' Given the methylation sequencing data of a cell-free DNA (cfDNA) sample, 
#' for each cancer marker or tissue marker, we deconvolve the tumor-derived 
#' or tissue-specific reads from all reads falling in the marker region. 
#' Our read-based deconvolution algorithm exploits the pervasiveness of 
#' DNA methylation for signal enhancement, therefore can sensitively identify 
#' a trace amount of tumor-specific or tissue-specific cfDNA in plasma.
#' 
#' @details
#' Specifically, cfTools can deconvolve different sources of 
#' cfDNA fragments (or reads) in two contexts:
#' 
#' 1. Cancer detection: separate cfDNA fragments into tumor-derived 
#' fragments and background normal fragments (2 classes), and estimate the 
#' tumor-derived cfDNA fraction.
#' 
#' 2. Tissue deconvolution: separate cfDNA fragments from different tissues 
#' (> 2 classes), and estimate the cfDNA fraction of different tissue types 
#' (including an unknown type) for a plasma cfDNA sample.
#'
#' These functions can serve as foundations for more advanced cfDNA-based studies, 
#' including cancer diagnosis and disease monitoring.
#' 
#' For an overview of the functionality provided by the package, please see the
#' vignette:
#' \code{vignette(package="cfTools")}
#'
#' @author 
#' Ran Hu \email{huran@ucla.edu}, 
#' Mary Louisa Stackpole,
#' Shuo Li,
#' Xianghong Jasmine Zhou \email{XJZhou@mednet.ucla.edu},
#' Wenyuan Li \email{WenyuanLi@mednet.ucla.edu}
#' 
#' @seealso \code{\link{CancerDetector}}, \code{\link{cfDeconvolve}}, 
#' \code{\link{cfSort}}, \code{\link{MergeCpGs}}, \code{\link{MergePEReads}},
#' \code{\link{GenerateFragMeth}}, \code{\link{GenerateMarkerParam}}, 
#' \code{\link{PlotFractionPie}}
#' 
#' @docType package
#' @name cfTools
#' 
#' @keywords internal
NULL

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

read_deconvolution_cpp <- function(reads_binning_file, num_tissues, min_likelihood_ratio_cutoff, tissue_markers_file, em_algorithm_type, output_file, output_type, em_max_iterations = 100L, random_seed = 0L) {
    invisible(.Call(`_cfTools_read_deconvolution_cpp`, reads_binning_file, num_tissues, min_likelihood_ratio_cutoff, tissue_markers_file, em_algorithm_type, output_file, output_type, em_max_iterations, random_seed))
}

count_meth_unmeth <- function(methString) {
    methVector <- as.numeric(strsplit(methString, "")[[1]])
    meth_count <- sum(methVector)
    unmeth_count <- length(methVector) - meth_count
    return(c(meth_count, unmeth_count))
}

#' @title
#' cfDNA methylation read deconvolution
#'
#' @description
#' Infer the tissue-type composition of plasma cfDNA.
#'
#' @param readsBinningFile a file of the fragment-level methylation states 
#' of reads that mapped to the markers. Either in plain text or compressed form.
#' @param tissueMarkersFile a file of paired shape parameters of beta 
#' distributions for markers.
#' @param numTissues a number of tissue types.
#' @param emAlgorithmType a read-based tissue deconvolution EM algorithm type: 
#' em.global.unknown (default), em.global.known, em.local.unknown, 
#' em.local.known.
#' @param likelihoodRatioThreshold a positive float number. Default is 2. 
#' @param emMaxIterations a number of EM algorithm maximum iteration. 
#' Default is 100.
#' @param randomSeed a random seed that initialize the EM algorithm. 
#' Default is 0.
#' @param id the sample ID.
#'
#' @return a list containing the cfDNA fractions of different 
#' tissue types and an unknown class.
#'
#' @examples
#' ## input files
#' demo.dir <- system.file("data", package="cfTools")
#' readsBinningFile <- file.path(demo.dir, "cfDeconvolve.reads.txt.gz")
#' tissueMarkersFile <- file.path(demo.dir, "cfDeconvolve.markers.txt.gz")
#' numTissues <- 7
#' emAlgorithmType <- "em.global.unknown"
#' likelihoodRatioThreshold <- 2
#' emMaxIterations <- 100
#' randomSeed <- 0
#' id <- "test"
#'
#' cfDeconvolve(readsBinningFile, tissueMarkersFile, numTissues, 
#' emAlgorithmType, likelihoodRatioThreshold, emMaxIterations, randomSeed, id)
#'
#' @export
cfDeconvolve <- function(readsBinningFile, tissueMarkersFile, numTissues,
                        emAlgorithmType="em.global.unknown", 
                        likelihoodRatioThreshold=2, 
                        emMaxIterations=100, randomSeed=0, id="sample") {

    extdata.dir <- system.file("data", package = "cfTools", mustWork = TRUE)
    output.dir <- extdata.dir
    
    timeNow <- strsplit(strsplit(as.character(Sys.time()), 
                        " ")[[1]][2], ":")[[1]]
    id <- paste0(id, timeNow[1], timeNow[2], timeNow[3])
    
    # output.dir <- paste0(extdata.dir, "/tmp/")
    # if (system.file("extdata/tmp", package = "cfTools") == "") {
    #   system2(command = "mkdir", args = output.dir)
    # }
    # id <- strsplit(as.character(Sys.time()), " ")[[1]][2]
    
    readsBinningFile.count <- file.path(output.dir, paste0(id, 
                                        ".reads_count.txt"))
    readsBinning <- read.csv(readsBinningFile, header=TRUE, sep="\t", 
                            colClasses = "character")
    colnames(readsBinning) <- c("markerName", "methState")
    meth_unmeth_count <- lapply(readsBinning$methState, count_meth_unmeth)
    readsBinningFile.input <- cbind(readsBinning$markerName, 
                                    data.frame(t(vapply(meth_unmeth_count, 
                                                        c, numeric(2)))))
    colnames(readsBinningFile.input) <- c("marker_index", "meth_count", 
                                        "unmeth_count")
    write.table(readsBinningFile.input, readsBinningFile.count, sep="\t", 
                row.names=FALSE, quote=FALSE)
    
    outputFile <- file.path(output.dir, paste0(id, ".profile"))
    
    if (endsWith(tissueMarkersFile, ".gz")) {
        gunzip(tissueMarkersFile, remove=FALSE)
        tissueMarkersFile.unzip <- strsplit(tissueMarkersFile, ".gz")[[1]]
        
        read_deconvolution_cpp(readsBinningFile.count, numTissues, 
                               likelihoodRatioThreshold, tissueMarkersFile.unzip,
                               emAlgorithmType, outputFile, "tissueFraction", 
                               emMaxIterations, randomSeed)
        file.remove(tissueMarkersFile.unzip)
    } else {
        read_deconvolution_cpp(readsBinningFile.count, numTissues, 
                               likelihoodRatioThreshold, tissueMarkersFile,
                               emAlgorithmType, outputFile, "tissueFraction", 
                               emMaxIterations, randomSeed)
    }

    output <- read.csv(outputFile, header=TRUE, sep="\t")
    # system2(command = "rm", args = outputFile)
    # system2(command = "rm", args = readsBinningFile.count)
    
    file.remove(outputFile)
    file.remove(readsBinningFile.count)
    
    return(output)

}

test_that("cfDeconvolve() works", {
  
    demo.dir <- system.file("data", package="cfTools")
    readsBinningFile <- file.path(demo.dir, "cfDeconvolve.reads.txt.gz")
    tissueMarkersFile <- file.path(demo.dir, "cfDeconvolve.markers.txt.gz")
    numTissues <- 7
    emAlgorithmType <- "em.global.unknown"
    likelihoodRatioThreshold <- 2
    
    result_cfDeconvolve <- cfDeconvolve(readsBinningFile, 
                                        tissueMarkersFile, 
                                        numTissues, emAlgorithmType, 
                                        likelihoodRatioThreshold)
    
    expect_type(result_cfDeconvolve, "list")
})

#' Paired-end sequencing reads
#'
#' Paired-end sequencing reads information
#'
#' @name demo.sorted.bed
#' 
#' @return A tibble with 1117 rows and 6 variables
#' 
#' @format A tibble with 1117 rows and 6 variables
#' \describe{
#' \item{chr}{Chromosome name}
#' \item{start}{Chromosome start}
#' \item{end}{Chromosome end}
#' \item{name}{Sequence ID}
#' \item{score}{Mapping quality score}
#' \item{strand}{Strand}
#' }
#' @usage data("demo.sorted.bed")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----"install", eval = FALSE--------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE)) {
#     install.packages("BiocManager")
# }
# BiocManager::install("cfTools")

## ----'install_dev', eval = FALSE----------------------------------------------
# BiocManager::install("jasminezhoulab/cfTools")

## ----demo---------------------------------------------------------------------
library(cfTools)
library(utils)
demo.dir <- system.file("data", package="cfTools")

## -----------------------------------------------------------------------------
PEReads <- file.path(demo.dir, "demo.sorted.bed.txt.gz")
head(read.table(PEReads, header=FALSE), 2)

## -----------------------------------------------------------------------------
fragInfo <- MergePEReads(PEReads)
head(fragInfo, 2)

## -----------------------------------------------------------------------------
CpG_OT <- file.path(demo.dir, "CpG_OT_demo.txt.gz")
CpG_OB <- file.path(demo.dir, "CpG_OB_demo.txt.gz")
head(read.table(CpG_OT, header=FALSE), 2)
head(read.table(CpG_OB, header=FALSE), 2)

## -----------------------------------------------------------------------------
methInfo <- MergeCpGs(CpG_OT, CpG_OB)
head(methInfo, 2)

## -----------------------------------------------------------------------------
fragMeth <- GenerateFragMeth(fragInfo, methInfo)
head(fragMeth, 2)

## -----------------------------------------------------------------------------
methLevel <- read.table(file.path(demo.dir, "beta_matrix.txt.gz"), 
                      row.names=1, header = TRUE)
sampleTypes <- read.table(file.path(demo.dir, "sample_type.txt.gz"), 
                        row.names=1, header = TRUE)$sampleType
markerNames <- read.table(file.path(demo.dir, "marker_index.txt.gz"), 
                        row.names=1, header = TRUE)$markerIndex
print(methLevel)
print(sampleTypes)
print(markerNames)

## -----------------------------------------------------------------------------
markerParam <- GenerateMarkerParam(methLevel, sampleTypes, markerNames)
print(markerParam)

## ----message=FALSE------------------------------------------------------------
library(GenomicRanges)

# a BED file of fragment-level methylation information
frag_bed <- read.csv(file.path(demo.dir, "demo.fragment_level.meth.bed.txt.gz"), 
                     header=TRUE, sep="\t")
frag_meth.gr <- GRanges(seqnames=frag_bed$chr, 
                     ranges=IRanges(frag_bed$start, frag_bed$end),
                     strand=frag_bed$strand,
                     methState=as.character(frag_bed$methState))

# a BED file of genomic regions of markers
markers_bed <- read.csv(file.path(demo.dir, "markers.bed.txt.gz"), 
                        header=TRUE, sep="\t")
markers.gr <- GRanges(seqnames=markers_bed$chr, 
                      ranges=IRanges(markers_bed$start, markers_bed$end),
                      markerName=markers_bed$markerName)

head(frag_meth.gr, 2)
head(markers.gr, 2)

## -----------------------------------------------------------------------------
ranges <- subsetByOverlaps(frag_meth.gr, markers.gr, ignore.strand=TRUE)
hits <- findOverlaps(frag_meth.gr, markers.gr,ignore.strand=TRUE)
idx <- subjectHits(hits)

values <- DataFrame(markerName=markers.gr$markerName[idx])
mcols(ranges) <- c(mcols(ranges), values)

marker.methState <- as.data.frame(cbind(ranges$markerName, 
                                        ranges$methState))
colnames(marker.methState) <- c("markerName", "methState")
head(marker.methState, 4)

## -----------------------------------------------------------------------------
fragMethFile <- file.path(demo.dir, "CancerDetector.reads.txt.gz")
markerParamFile <- file.path(demo.dir, "CancerDetector.markers.txt.gz")
head(read.csv(fragMethFile, sep = "\t", colClasses = "character"), 4)
head(read.csv(markerParamFile, sep = "\t"), 4)

## -----------------------------------------------------------------------------
CancerDetector(fragMethFile, markerParamFile, lambda=0.5, id="test")

## -----------------------------------------------------------------------------
fragMethFile2 <- file.path(demo.dir, "cfDeconvolve.reads.txt.gz")
markerParamFile2 <- file.path(demo.dir, "cfDeconvolve.markers.txt.gz")
head(read.csv(fragMethFile2, header=TRUE, sep="\t", 
              colClasses = "character"), 4)
head(read.csv(markerParamFile2, header=TRUE, sep="\t", 
              colClasses = "character"), 4)

## -----------------------------------------------------------------------------
numTissues <- 7
emAlgorithmType <- "em.global.unknown"
likelihoodRatioThreshold <- 2
emMaxIterations <- 100
randomSeed <- 0
id <- "test"

## ----message=TRUE-------------------------------------------------------------
tissueFraction <- cfDeconvolve(fragMethFile2, markerParamFile2, numTissues, 
                               emAlgorithmType, likelihoodRatioThreshold, 
                               emMaxIterations, randomSeed, id)
tissueFraction

## -----------------------------------------------------------------------------
fragMethInfo <- file.path(demo.dir, "cfsort_reads.txt.gz")
head(read.csv(fragMethInfo, header=TRUE, sep="\t", 
              colClasses = "character"), 4)

## ----message=FALSE------------------------------------------------------------
tissueFraction2 <- cfSort(fragMethInfo, id="demo")
tissueFraction2

## -----------------------------------------------------------------------------
cancer_normal_df <- CancerDetector(fragMethFile, markerParamFile, lambda=0.5, id="test")
PlotFractionPie(cancer_normal_df, title = "cfDNA Composition", class_colors = c("normal_cfDNA_fraction" = "blue"), font_size = 1.2)

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

#' Fragment-level information
#'
#' A BED file of fragment-level information
#'
#' @name demo.refo_frag.bed
#' 
#' @return A tibble with 559 rows and 6 variables
#' 
#' @format A tibble with 559 rows and 6 variables
#' \describe{
#' \item{chr}{Chromosome}
#' \item{start}{Chromosome start}
#' \item{end}{Chromosome end}
#' \item{fragmentLength}{Fragment length}
#' \item{strand}{Strand}
#' \item{name}{ID of the sequence}
#' }
#' @usage data("demo.refo_frag.bed")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' @title
#' Generate fragment-level methylation states of CpGs
#'
#' @description
#' Merge the methylation states of all CpGs corresponding to the 
#' same fragment onto one line in output.
#'
#' @param CpG_OT a file of methylation information for CpG on the 
#' original top strand (OT), 
#' which is one of the outputs from `bismark methylation extractor`.
#' @param CpG_OB a file of methylation information for CpG on the 
#' original bottom strand (OB), 
#' which is one of the outputs from `bismark methylation extractor`.
#' @param output.dir a path to the output directory. Default is "", 
#' which means the output will not be written into a file.
#' @param id an ID name for the input data. Default is "", 
#' which means the output will not be written into a file.
#' 
#' @return a list in BED file format and/or written to 
#' an output BED file.
#'
#' @examples
#' ## input files
#' demo.dir <- system.file("data", package="cfTools")
#' CpG_OT <- file.path(demo.dir, "CpG_OT_demo.txt.gz")
#' CpG_OB <- file.path(demo.dir, "CpG_OB_demo.txt.gz")
#'
#' output <- MergeCpGs(CpG_OT, CpG_OB)
#'
#' @export
MergeCpGs <- function(CpG_OT, CpG_OB, output.dir="", id="") {

    # options(scipen = 999)

    python.script.dir <- system.file("python", package = "cfTools", 
                                    mustWork = TRUE)
    hasOutput <- TRUE
    
    if (output.dir=="" | id=="") {
        hasOutput <- FALSE
        extdata.dir <- system.file("data", package = "cfTools", 
                                    mustWork = TRUE)
        output.dir <- extdata.dir
        
        timeNow <- strsplit(strsplit(as.character(Sys.time()), 
                                    " ")[[1]][2], ":")[[1]]
        id <- paste0(timeNow[1], timeNow[2], timeNow[3])
        
        # output.dir <- paste0(extdata.dir, "/tmp/")
        # if (system.file("extdata/tmp", package = "cfTools") == "") {
        #   system2(command = "mkdir", args = output.dir)
        # }
        # id <- strsplit(as.character(Sys.time()), " ")[[1]][2]
    }
    
    py2 <- paste0(python.script.dir, "/collapse_CpG.py")
    refo_meth <- file.path(output.dir, paste0(id, ".refo_meth.bed"))
    py2.command <- c(py2, CpG_OT, CpG_OB, refo_meth)
    
    proc <- basiliskStart(my_env)
    
    basiliskRun(proc, function() {
        system2(command = "python", args = py2.command)
    })
    basiliskStop(proc)
    
    output_bed <- read.csv(refo_meth, sep="\t", header = FALSE, 
                            colClasses = "character")
    output_bed <- as.data.frame(output_bed[order(output_bed$V8),])
    # nums<- sapply(output_bed, is.numeric)
    # output_bed$V7 <- format(output_bed$V7, scientific=F)
    # output_bed[ , nums] <- as.data.frame(apply(output_bed[ , nums], 
    #                                            2, as.character))
    rownames(output_bed) <- NULL
    colnames(output_bed) <- c("chr", "cpgStart", "cpgEnd", "strand", 
                            "cpgNumber", "cpgPosition", "methState", "qname")
    
    write.table(output_bed, refo_meth, sep="\t", row.names=FALSE, 
                quote = FALSE)
    if (!hasOutput) {
        file.remove(refo_meth)
    }
    
    return(output_bed)
}

test_that("MergeCpGs() works", {
  
  demo.dir <- system.file("data", package="cfTools")
  CpG_OT <- file.path(demo.dir, "CpG_OT_demo.txt.gz")
  CpG_OB <- file.path(demo.dir, "CpG_OB_demo.txt.gz")
  
  result_MergeCpGs <- MergeCpGs(CpG_OT, CpG_OB)
  
  expect_type(result_MergeCpGs, "list")
})

#' Fragment-level methylation state for tissue deconvolution
#'
#' The fragment-level methylation states of reads that mapped 
#' to the tissue-specific markers
#'
#' @name cfDeconvolve.reads
#' 
#' @return A tibble with 942 rows and 2 variables
#' 
#' @format A tibble with 942 rows and 2 variables
#' \describe{
#' \item{markerName}{Name of the marker}
#' \item{methState}{Fragment-level methylation states, 
#' which are represented by a sequence of binary values 
#' (0 represents unmethylated CpG and 1 represents methylated 
#' CpG on the same fragment)}
#' }
#' @usage data("cfDeconvolve.reads")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' Cancer-specific marker parameter
#'
#' The paired shape parameters of beta distributions 
#' for cancer-specific markers
#'
#' @name CancerDetector.markers
#' 
#' @return A tibble with 1266 rows and 3 variables
#' 
#' @format A tibble with 1266 rows and 3 variables
#' \describe{
#' \item{markerName}{Name of the marker}
#' \item{tumor}{Paired beta distribution shape parameters 
#' for tumor samples}
#' \item{normalPlasma}{Paired beta distribution shape 
#' parameters for normal plasma samples}
#' }
#' @usage data("CancerDetector.markers")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

#' @title
#' cfSort: tissue deconvolution 
#'
#' @description
#' Tissue deconvolution in cfDNA using DNN models.
#'
#' @param readsBinningFile a file of the fragment-level methylation states 
#' of reads that mapped to the cfSort markers. In compressed form.
#' @param id the sample ID.
#' 
#' @return the tissue composition of the cfDNA sample.
#' 
#' @examples
#' ## input files
#' demo.dir <- system.file("data", package="cfTools")
#' readsBinningFile <- file.path(demo.dir, "cfsort_reads.txt.gz")
#' id <- "test"
#'
#' cfSort(readsBinningFile, id)
#' 
#' @export
cfSort <- function(readsBinningFile, id="sample") {
  
  python.script.dir <- system.file("python", package = "cfTools", 
                                   mustWork = TRUE)
  
  extdata.dir <- system.file("data", package = "cfTools", mustWork = TRUE)
  cfSortMarkerFile <- file.path(extdata.dir, "cfsort_markers.txt.gz")

  # timeNow <- strsplit(strsplit(as.character(Sys.time()), 
  #                              " ")[[1]][2], ":")[[1]]
  # id <- paste0(id, timeNow[1], timeNow[2], timeNow[3])
  
  alpha_value_distr <- file.path(extdata.dir, paste0(id, ".alpha_value_distr.txt.gz"))
  mat <- file.path(extdata.dir, paste0(id, ".mat.txt.gz"))
  depthFile <- file.path(extdata.dir, paste0(id, ".depth.txt"))
  featuresFile <- file.path(extdata.dir, paste0(id, ".features.txt.gz"))
  tfrecords <- file.path(extdata.dir, paste0(id, ".tfrecords"))
  
  py1 <- paste0(python.script.dir, 
                "/convert_binary_meth_to_alpha_value_distribution.py")
  py1.command <- c(py1, readsBinningFile, alpha_value_distr)
  
  py2 <- paste0(python.script.dir, 
                "/generate_data_matrix_by_alpha_value_and_markers.py")
  py2.command <- c(py2, cfSortMarkerFile, alpha_value_distr, mat)
  
  proc <- basiliskStart(my_env)
  
  basiliskRun(proc, function() {
    system2(command = "python", args = py1.command)
    system2(command = "python", args = py2.command)
  })
  basiliskStop(proc)
  
  ### collect read depth at markers
  input_file <- alpha_value_distr
  output_file <- depthFile
  marker_file <- cfSortMarkerFile
  MAX_INDEX <- 1045098
  
  marker <- read.table(marker_file, header = TRUE)$marker_index
  dt <- matrix(NA, ncol = length(marker), nrow = 1)
  rownames(dt) <- input_file
  cur_x <- read.table(input_file, header = TRUE)
  cur_x <- cur_x[cur_x$marker_index %in% marker, ]
  cur_x <- cur_x[! duplicated(cur_x$marker_index),]
  rownames(cur_x) <- as.character(cur_x$marker_index)
  dt[input_file,] <- cur_x[as.character(marker), "num_read"]
  dt[is.na(dt)] <- 0
  dt <- data.frame(dt)
  write.table(dt, output_file, col.names = FALSE, row.names = TRUE, 
              quote = FALSE, sep = "\t")
  
  ## final step
  py3 <- paste0(python.script.dir, 
                "/normalize_local_read_depth_and_cluster_markers.py")
  py3.command <- c(py3, cfSortMarkerFile, mat, depthFile, featuresFile)
  
  norm_params <- paste0(python.script.dir, "/norm_params.npy")
  
  py4 <- paste0(python.script.dir, 
                "/data_prep.for_test_only.py")
  py4.command <- c(py4, featuresFile, tfrecords, norm_params)
  
  proc <- basiliskStart(my_env)
  
  basiliskRun(proc, function() {
    system2(command = "python", args = py3.command)
    system2(command = "python", args = py4.command)
  })
  basiliskStop(proc)
  
  file.remove(mat)
  file.remove(depthFile)
  file.remove(alpha_value_distr)
  file.remove(featuresFile)
  
  # return(tfrecords)
  
  ###### cfSort
  output.dir <- extdata.dir
  tissue.composition.1 <- file.path(output.dir, 
                                    paste0(id, ".tissue_composition.1.txt"))
  tissue.composition.2 <- file.path(output.dir, 
                                    paste0(id, ".tissue_composition.2.txt"))
  
  # model_DNN1 <- DNN1()
  # model_DNN2 <- DNN2()
  suppressMessages({
      model_DNN1 <- DNN1()
      model_DNN2 <- DNN2()
  })
  
  py5 <- paste0(python.script.dir, "/model_pred.py")
  py5.command <- c(py5, tfrecords, model_DNN1, tissue.composition.1)
  py6.command <- c(py5, tfrecords, model_DNN2, tissue.composition.2)
  
  proc <- basiliskStart(my_env)
  
  basiliskRun(proc, function() {
      # system2(command = "python", args = py5.command)
      # system2(command = "python", args = py6.command)
      system2(command = "python", args = py5.command, env = c("PYTHONWARNINGS=ignore", "TF_CPP_MIN_LOG_LEVEL=2"))
      system2(command = "python", args = py6.command, env = c("PYTHONWARNINGS=ignore", "TF_CPP_MIN_LOG_LEVEL=2"))
  })
  basiliskStop(proc)
  
  tissue_composition_1 <- read.csv(tissue.composition.1, 
                                   header = FALSE, sep = "\t")
  tissue_composition_2 <- read.csv(tissue.composition.2, 
                                   header = FALSE, sep = "\t")
  
  tissue_composition <- (tissue_composition_1 + tissue_composition_2)/2
  colnames(tissue_composition) <- c("adipose_tissue", "adrenal_gland", "bladder", 
                              "blood_vessel", "breast", "cervix_uteri", 
                              "colon", "esophagus", "fallopian_tube", "heart", 
                              "kidney", "liver", "lung", "muscle", "nerve", 
                              "ovary", "pancreas", "pituitary", "prostate", 
                              "salivary_gland", "skin", "small_intestine", 
                              "spleen", "stomach", "testis", "thyroid", 
                              "uterus", "vagina", "WBC")
  
  file.remove(tfrecords)
  file.remove(tissue.composition.1)
  file.remove(tissue.composition.2)

  return(tissue_composition)
}

test_that("cfSort() works", {

    demo.dir <- system.file("data", package="cfTools")
    readsBinningFile <- file.path(demo.dir, "cfsort_reads.txt.gz")
    id <- "test"
    
    output <- cfSort(readsBinningFile, id)
    
    expect_equal(output$adipose_tissue, 0)
    expect_equal(output$WBC, 1)
})

#' cfSort markers
#'
#' Marker information for the cfSort function, 
#' where each row is the information about a marker
#'
#' @name cfsort_markers
#' 
#' @return A tibble with 51035 rows and 4 variables
#' 
#' @format A tibble with 51035 rows and 4 variables
#' \describe{
#' \item{marker_index}{The marker index used in cfSort method}
#' \item{alpha_threshold}{The alpha threshold for each marker}
#' \item{pair}{The pair of tissues used for identifying the marker}
#' \item{group}{The group number for each marker}
#' }
#' @usage data("cfsort_markers")
#' 
#' @author Ran Hu \email{huran@ucla.edu}
NULL

---
title: "Analyzing cell-free DNA methylation data with cfTools"
author: 
  - name: Ran Hu
    affiliation:
      - Department of Pathology and Laboratory Medicine, David Geffen School of Medicine, University of California at Los Angeles
      - Institute for Quantitative and Computational Biosciences, University of California at Los Angeles
      - Bioinformatics Interdepartmental Graduate Program, University of California at Los Angeles
    email: huran@ucla.edu
  - name: Mary Louisa Stackpole
    affiliation:
      - Department of Pathology and Laboratory Medicine, David Geffen School of Medicine, University of California at Los Angeles
  - name: Shuo Li
    affiliation:
      - Department of Pathology and Laboratory Medicine, David Geffen School of Medicine, University of California at Los Angeles
  - name: Xianghong Jasmine Zhou
    affiliation:
      - Department of Pathology and Laboratory Medicine, David Geffen School of Medicine, University of California at Los Angeles
      - Institute for Quantitative and Computational Biosciences, University of California at Los Angeles
  - name: Wenyuan Li
    affiliation:
      - Department of Pathology and Laboratory Medicine, David Geffen School of Medicine, University of California at Los Angeles
package: cfTools
output: 
  BiocStyle::html_document:
    toc: true
    toc_float: true
    theme: flatly
    highlight: pygments
  BiocStyle::pdf_document: default
abstract: >
  Cell-free DNA (cfDNA) in blood has emerged as an ideal surrogate for 
  tumor biopsy. It can be obtained noninvasively, and provides a 
  comprehensive landscape of the heterogeneous genetic and epigenetic 
  alterations in tumors. The `r Biocpkg("cfTools")` package provides 
  methods for cfDNA methylation data analysis to facilitate cfDNA-based 
  tumor-derived cfDNA to determine whether plasma samples are from cancer 
  tissue composition of plasma samples.
  cancer studies, including (1) cancer detection: sensitively detect 
  patients or normal individuals; (2) tissue deconvolution: infer the 
vignette: >
  %\VignetteIndexEntry{cfTools-vignette}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction

Given the methylation sequencing data of a cell-free DNA (cfDNA) sample, 
for each cancer marker or tissue marker, we deconvolve the tumor-derived 
or tissue-specific reads from all reads falling in the marker region. 
Our read-based deconvolution algorithm exploits the pervasiveness of 
DNA methylation for signal enhancement, therefore can sensitively identify 
a trace amount of tumor-specific or tissue-specific cfDNA in plasma. 

Specifically, `r Biocpkg("cfTools")` can deconvolve different sources of 
cfDNA fragments (or reads) in two contexts:

1. Cancer detection [1]: separate cfDNA fragments into tumor-derived 
fragments and background normal fragments (2 classes), and estimate the 
tumor-derived cfDNA fraction $\theta$ ($0\leq \theta < 1$).

2. Tissue deconvolution [2,3]: separate cfDNA fragments from different tissues 
(> 2 classes), and estimate the cfDNA fraction $\theta_t$ 
($0\leq \theta_t < 1$) of different tissue types (including an unknown type) 
$t$ for a plasma cfDNA sample.

These functions can serve as foundations for more advanced cfDNA-based studies, 
including cancer diagnosis and disease monitoring.

# Installation

`r Biocpkg("cfTools")` is an `R` package available via the 
[Bioconductor](http://bioconductor.org) repository for packages. 
You can install the release version by using the following commands 
in your `R` session:

```{r "install", eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}
BiocManager::install("cfTools")
```

Alternatively, you can install the development version from 
[GitHub](https://github.com/) :

```{r 'install_dev', eval = FALSE}
BiocManager::install("jasminezhoulab/cfTools")
```

# Input data preparation

The two main input files for `CancerDetector()` and `cfDeconvolve()` are

* **Input 1**: fragment-level methylation states (methState), 
which are represented by a sequence of binary values (0 represents 
unmethylated CpG and 1 represents methylated CpG on the same fragment);

* **Input 2**: methylation pattern (paired shape parameters of beta 
distributions) of markers. 

`cfSort()` mainly takes **Input 1** as the only input file.

Section 3.1, 3.2, 3.3 provide an example for generating **Input 1**. 
We require users to provide pre-processed paired-end bisulfite sequencing 
reads (i.e., aligned to the reference genome). For each cfDNA sample, 
users need to prepare (1) the standard (sorted) BED file of the aligned 
reads and (2) the methylation information that *bismark* extracts from 
the aligned reads as input data files. Specifically, 

* Section 3.1 `MergePEReads()`
  * Input: a standard (sorted) BED file of paired-end sequencing reads
    - How to prepare the BED file from the BAM file produced after reads 
    alignment to the reference genome with *bismark*
    `bedtools bamtobed -i <unsorted_bam> | sort -k1,1 -k2,2n | \`
    `gzip > <out_bed_sorted>`
  * Output: fragment-level information of cfDNA reads
* Section 3.2 `MergeCpGs()`
  * Input: a `CpG_OT*` file and a `CpG_OB*` file generated by 
  *bismark methylation extractor*
    - How to use *bismark methylation extractor*
    `samtools sort -n <unsorted_bam> -o <out_bam_sortn>`
    `bismark_methylation_extractor -p --bedGraph --gzip --counts --buffer_size\`
    ` 11G --genome_folder <genome_folder> --output <output_dir> <out_bam_sortn>`
  * Output: methylation information of all CpGs on the same fragment
* Section 3.3 `GenerateFragMeth()`
  * Input: the output lists of `MergePEReads()` and `MergeCpGs()`
  * Output: fragment-level information about methylation states
  
Section 3.4 provides an example for generating **Input 2**. Specifically,

* Section 3.4 `GenerateMarkerParam()`
  * Input: a list of methylation levels (e.g., beta values) for markers, 
  a vector of sample types (e.g., tumor or normal, tissue types) corresponding 
  to the rows of the list, a vector of marker names corresponding to the 
  columns of the list
  * Output: a list containing the paired shape parameters of beta 
  distributions for markers

Example input data files are included within the package:

```{r demo}
library(cfTools)
library(utils)
demo.dir <- system.file("data", package="cfTools")
```
 
## Merge paired-end sequencing reads to fragment-level

Function `MergePEReads()` generates fragment-level information for 
paired-end sequencing reads. The main input file is a standard (sorted) 
BED file (e.g. output of *bedtools bamtobed*) of paired-end sequencing 
reads containing columns of chromosome name, chromosome start, 
chromosome end, sequence ID, mapping quality score, and strand. 

```{r}
PEReads <- file.path(demo.dir, "demo.sorted.bed.txt.gz")
head(read.table(PEReads, header=FALSE), 2)
```

The output is a list in BED file format and/or written to an output 
BED file, where each line contains the information of a cfDNA fragment.

```{r}
fragInfo <- MergePEReads(PEReads)
head(fragInfo, 2)
```

## Merge methylation states of CpGs on two strands to fragment-level

Function `MergeCpGs()` generates fragment-level methylation states of CpGs. 
The main inputs of it are two output files of *bismark methylation extractor*, 
which is a program performing methylation calling on bisulfite treated 
sequencing reads. The `CpG_OT*` file contains methylation information for 
CpGs on the original top strand (OT); the `CpG_OB*` file contains methylation 
information for CpGs on the original bottom strand (OB). Both files contain 
columns of sequence ID, methylation state, chromosome name, chromosome start, 
methylation call.

```{r}
CpG_OT <- file.path(demo.dir, "CpG_OT_demo.txt.gz")
CpG_OB <- file.path(demo.dir, "CpG_OB_demo.txt.gz")
head(read.table(CpG_OT, header=FALSE), 2)
head(read.table(CpG_OB, header=FALSE), 2)
```
The output is a list in BED file format and/or written to an output 
BED file, where each line contains methylation states of all CpGs on the 
same fragment. Column *methState* is a sequence of binary values indicating 
the methylation states of all CpGs on the same fragment (0 represents 
unmethylated CpG and 1 represents methylated CpG).

```{r}
methInfo <- MergeCpGs(CpG_OT, CpG_OB)
head(methInfo, 2)
```

## Generate fragment-level information about methylation states

Function `GenerateFragMeth()` combines the output lists of 
`MergePEReads()` and `MergeCpGs()` into one list, 
which contains both the fragment information and the methylation 
states of all CpGs on each fragment. 

```{r}
fragMeth <- GenerateFragMeth(fragInfo, methInfo)
head(fragMeth, 2)
```

## Generate the methylation pattern of markers

Function `GenerateMarkerParam()` calculates paired shape parameters 
of beta distributions for each marker. There are three main inputs 
to this function: (1) a list of methylation levels (e.g., 
beta values), where each row is a sample and each column is a marker; 
(2) a vector of sample types (e.g., tumor or normal, tissue types) 
corresponding to the rows of the list; (3) a vector of marker 
names corresponding to the columns of the list.

```{r}
methLevel <- read.table(file.path(demo.dir, "beta_matrix.txt.gz"), 
                      row.names=1, header = TRUE)
sampleTypes <- read.table(file.path(demo.dir, "sample_type.txt.gz"), 
                        row.names=1, header = TRUE)$sampleType
markerNames <- read.table(file.path(demo.dir, "marker_index.txt.gz"), 
                        row.names=1, header = TRUE)$markerIndex
print(methLevel)
print(sampleTypes)
print(markerNames)
```

The output is a list containing the paired shape parameters of 
beta distributions for markers, which are delimited by `:`. Users can 
save this list into a file with column names, no row names, and 
columns are delimited by TAB for later use.

```{r}
markerParam <- GenerateMarkerParam(methLevel, sampleTypes, markerNames)
print(markerParam)
```

Note that parameter value `NA:NA` or `0:0` may cause errors in the 
following analyses. Remove these values before using this file.

# Fragments intersecting with marker regions

To make the computation more efficient, users may only keep the fragments 
that overlap with the genomic regions of markers. Here, we provide an 
example of using `R` package `r Biocpkg("GenomicRanges")` to perform the 
intersection. 

First, transform the two BED files into GRanges classes.

```{r message=FALSE}
library(GenomicRanges)

# a BED file of fragment-level methylation information
frag_bed <- read.csv(file.path(demo.dir, "demo.fragment_level.meth.bed.txt.gz"), 
                     header=TRUE, sep="\t")
frag_meth.gr <- GRanges(seqnames=frag_bed$chr, 
                     ranges=IRanges(frag_bed$start, frag_bed$end),
                     strand=frag_bed$strand,
                     methState=as.character(frag_bed$methState))

# a BED file of genomic regions of markers
markers_bed <- read.csv(file.path(demo.dir, "markers.bed.txt.gz"), 
                        header=TRUE, sep="\t")
markers.gr <- GRanges(seqnames=markers_bed$chr, 
                      ranges=IRanges(markers_bed$start, markers_bed$end),
                      markerName=markers_bed$markerName)

head(frag_meth.gr, 2)
head(markers.gr, 2)
```

Then, overlap two GRanges classes and get the fragment-level methylation 
states intersecting with the markers.

```{r}
ranges <- subsetByOverlaps(frag_meth.gr, markers.gr, ignore.strand=TRUE)
hits <- findOverlaps(frag_meth.gr, markers.gr,ignore.strand=TRUE)
idx <- subjectHits(hits)

values <- DataFrame(markerName=markers.gr$markerName[idx])
mcols(ranges) <- c(mcols(ranges), values)

marker.methState <- as.data.frame(cbind(ranges$markerName, 
                                        ranges$methState))
colnames(marker.methState) <- c("markerName", "methState")
head(marker.methState, 4)
```

# Cancer detection with `CancerDetector()`

Function `CancerDetector()` separates cfDNA into tumor-derived fragments 
and background normal fragments and estimates the tumor burden. The main 
inputs are two files: (1) the fragment-level methylation states of reads 
(column `methState`) that mapped to the cancer-specific markers; 
(2) paired shape parameters of beta distributions for cancer-specific markers. 
All columns are delimited by TAB, and the first line is the column names. 
In addition, users can tune the parameter `lambda` to adjust the relative 
level of tumor burden.

```{r}
fragMethFile <- file.path(demo.dir, "CancerDetector.reads.txt.gz")
markerParamFile <- file.path(demo.dir, "CancerDetector.markers.txt.gz")
head(read.csv(fragMethFile, sep = "\t", colClasses = "character"), 4)
head(read.csv(markerParamFile, sep = "\t"), 4)
```

The output is the estimated tumor burden $\theta$ and the normal 
cfDNA fraction $1-\theta$.

```{r}
CancerDetector(fragMethFile, markerParamFile, lambda=0.5, id="test")
```

# Tissue deconvolution with `cfDeconvolve()`

Function `cfDeconvolve()` estimates fractions of cfDNA fragments from 
different tissues (> 2 classes). The main two input files are similar 
to function `CancerDetector()`: (1) the fragment-level methylation states 
of reads (column `methState`) that mapped to the tissue-specific markers; 
(2) paired shape parameters of beta distributions for tissue-specific 
markers. All columns are delimited by TAB, and there is a header line of 
the column names.

```{r}
fragMethFile2 <- file.path(demo.dir, "cfDeconvolve.reads.txt.gz")
markerParamFile2 <- file.path(demo.dir, "cfDeconvolve.markers.txt.gz")
head(read.csv(fragMethFile2, header=TRUE, sep="\t", 
              colClasses = "character"), 4)
head(read.csv(markerParamFile2, header=TRUE, sep="\t", 
              colClasses = "character"), 4)
```
Other input parameters are:

- **Number of tissue types**: a positive integer number *k*. Reads will 
be classified into *k* different tissue types.
- **Read-based tissue deconvolution EM algorithm type**: options are 
`em.global.unknown` (default), `em.global.known`, `em.local.unknown`, 
`em.local.known`.
- **Likelihood ratio threshold**: a positive float number. We suggest this 
number is 2 (default). All reads with likelihood ratio < cutoff (default: 
-1.0, meanin no reads filtering is used) will not be used. Likelihood ratio 
is the max(all tissues' likelihoods)/min(all tissues' likelihoods).
- **EM algorithm maximum iteration number**: a positive integer number. 
Default is 100.
- **Random seed**: a random seed that initialize the EM algorithm. Default is 0.
- **Sample ID**: the unique sample ID.

For example:
```{r}
numTissues <- 7
emAlgorithmType <- "em.global.unknown"
likelihoodRatioThreshold <- 2
emMaxIterations <- 100
randomSeed <- 0
id <- "test"
```

The output is a list containing the cfDNA fractions of different 
tissue types and an unknown class.

```{r, message=TRUE}
tissueFraction <- cfDeconvolve(fragMethFile2, markerParamFile2, numTissues, 
                               emAlgorithmType, likelihoodRatioThreshold, 
                               emMaxIterations, randomSeed, id)
tissueFraction
```

# Tissue deconvolution with `cfSort()`

Function `cfSort()` estimates fractions of cfDNA fragments derived from 29 
major human tissues. It is the first supervised tissue deconvolution 
approach with deep learning models. The main input file is similar to function 
`CancerDetector()` and `cfDeconvolve()`: the fragment-level methylation 
states of reads (column `methState`) that mapped to the tissue-specific 
markers. The first column is the marker name of cfSort markers. 

```{r}
fragMethInfo <- file.path(demo.dir, "cfsort_reads.txt.gz")
head(read.csv(fragMethInfo, header=TRUE, sep="\t", 
              colClasses = "character"), 4)
```

To obtain the `markerName` column, intersect the output file from 
`GenerateFragMeth()` (fragment-level information about methylation states) with 
the cfSort marker file 
https://github.com/jasminezhoulab/cfSort/blob/main/marker/cfSort_markers.txt.gz 
using genomic coordinates (hg19). Use the `region_index` column from the marker 
file as the `markerName`, and retain the `methState` column.

The output is a list containing the cfDNA fractions of 29 tissue types.

```{r, message=FALSE}
tissueFraction2 <- cfSort(fragMethInfo, id="demo")
tissueFraction2
```

# Visualization with `PlotFractionPie()`

Function `PlotFractionPie()` generates a pie chart for a vector of cfDNA 
fractions. The main input is a numeric vector of class-specific fractions.
The title, colors, and font size can be adjusted to enhance the look of the 
figure.

```{r}
cancer_normal_df <- CancerDetector(fragMethFile, markerParamFile, lambda=0.5, id="test")
PlotFractionPie(cancer_normal_df, title = "cfDNA Composition", class_colors = c("normal_cfDNA_fraction" = "blue"), font_size = 1.2)
```

# Reference

[1] Li W, Li Q, Kang S, Same M, Zhou Y, Sun C, Liu CC, Matsuoka L, Sher L, 
Wong WH, Alber F, Zhou XJ. CancerDetector: ultrasensitive and non-invasive 
cancer detection at the resolution of individual reads using cell-free DNA 
methylation sequencing data. *Nucleic Acids Res*. 2018 Sep 6;46(15):e89. 
doi: 10.1093/nar/gky423. PMID: 29897492; PMCID: PMC6125664.

[2] Del Vecchio G, Li Q, Li W, Thamotharan S, Tosevska A, Morselli M, Sung K, 
Janzen C, Zhou X, Pellegrini M, Devaskar SU. Cell-free DNA methylation and 
transcriptomic signature prediction of pregnancies with adverse outcomes. 
*Epigenetics*. 2021 Jun;16(6):642-661. doi: 10.1080/15592294.2020.1816774. 
PMID: 33045922; PMCID: PMC8143248.

[3] Li S, Zeng W, Ni X, Liu Q, Li W, Stackpole ML, Zhou Y, Gower A, Krysan K, 
Ahuja P, Lu DS, Raman SS, Hsu W, Aberle DR, Magyar CE, French SW, Han SB, 
Garon EB, Agopian VG, Wong WH, Dubinett SM, Zhou XJ. Comprehensive tissue 
deconvolution of cell-free DNA by deep learning for disease diagnosis and 
monitoring. *Proc Natl Acad Sci U S A*. 2023 Jul 11;120(28):e2305236120. 
doi: 10.1073/pnas.2305236120. Epub 2023 Jul 3. PMID: 37399400.

# Session info {-}
```{r sessionInfo, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenerateMarkerParam.R
\name{GenerateMarkerParam}
\alias{GenerateMarkerParam}
\title{Generate the methylation pattern of markers}
\usage{
GenerateMarkerParam(x, sample.types, marker.names, output.file = "")
}
\arguments{
\item{x}{a list of methylation levels (e.g., beta values), 
where each row is a sample and each column is a marker.}

\item{sample.types}{a vector of sample types (e.g., tumor or normal, 
tissue types) corresponding to the rows of the list.}

\item{marker.names}{a vector of marker names corresponding to the 
columns of the list.}

\item{output.file}{a character string naming the output file. 
Default is "", which means the output will not be written into a file.}
}
\value{
a list containing the paired shape parameters of 
beta distributions for markers and/or written to an output file.
}
\description{
Output paired shape parameters of beta distributions for methylation markers.
}
\examples{
## input files
demo.dir <- system.file("data", package="cfTools")
methLevel <- read.table(file.path(demo.dir, "beta_matrix.txt.gz"), 
row.names=1, header = TRUE)
sampleTypes <- read.table(file.path(demo.dir, "sample_type.txt.gz"), 
row.names=1, header = TRUE)$sampleType
markerNames <- read.table(file.path(demo.dir, "marker_index.txt.gz"), 
row.names=1, header = TRUE)$markerIndex

output <- GenerateMarkerParam(methLevel, sampleTypes, markerNames)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MergePEReads.R
\name{MergePEReads}
\alias{MergePEReads}
\title{Generate fragment-level information for paired-end sequencing reads}
\usage{
MergePEReads(bed_file, output.dir = "", id = "")
}
\arguments{
\item{bed_file}{a (sorted) BED file of paired-end reads.}

\item{output.dir}{a path to the output directory. Default is "", 
which means the output will not be written into a file.}

\item{id}{an ID name for the input data. Default is "", 
which means the output will not be written into a file.}
}
\value{
a list in BED file format and/or written to 
an output BED file.
}
\description{
Merge BED file (the output of `bedtools bamtobed`) to 
fragment-level for paired-end sequencing reads.
}
\examples{
## input files
demo.dir <- system.file("data", package="cfTools")
PEReads <- file.path(demo.dir, "demo.sorted.bed.txt.gz")

output <- MergePEReads(PEReads)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-markers.bed.R
\name{markers.bed}
\alias{markers.bed}
\title{Genomic postions of markers}
\format{
A tibble with 3 rows and 4 variables
\describe{
\item{chr}{Chromosome}
\item{start}{Chromosome start}
\item{end}{Chromosome end}
\item{markerName}{Marker name}
}
}
\usage{
data("markers.bed")
}
\value{
A tibble with 3 rows and 4 variables
}
\description{
A BED file of genomic regions of markers
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-demo.fragment_level.meth.bed.R
\name{demo.fragment_level.meth.bed}
\alias{demo.fragment_level.meth.bed}
\title{Fragment-level methylation information}
\format{
A tibble with 552 rows and 9 variables
\describe{
\item{chr}{Chromosome}
\item{start}{Chromosome start}
\item{end}{Chromosome end}
\item{name}{ID of the sequence}
\item{fragmentLength}{Fragment length}
\item{strand}{Strand}
\item{cpgNumber}{Number of CpG sites on the fragment}
\item{cpgPosition}{Postions of CpG sites on the fragment}
\item{methState}{A string of methylation states of 
CpG sites on the fragment}
}
}
\usage{
data("demo.fragment_level.meth.bed")
}
\value{
A tibble with 552 rows and 9 variables
}
\description{
A BED file of fragment-level methylation information
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CancerDetector.R
\name{CancerDetector}
\alias{CancerDetector}
\title{Cancer Detector}
\usage{
CancerDetector(
  readsBinningFile,
  tissueMarkersFile,
  lambda = 0.5,
  id = "sample"
)
}
\arguments{
\item{readsBinningFile}{a file of the fragment-level methylation states 
of reads that mapped to the markers.}

\item{tissueMarkersFile}{a file of paired shape parameters of beta 
distributions for markers.}

\item{lambda}{a number controlling "confounding" markers' distance 
from average markers.}

\item{id}{the sample ID.}
}
\value{
a list containing the cfDNA tumor burden 
and the normal cfDNA fraction.
}
\description{
Detect tumor-derived cfDNA and estimate the tumor burden.
}
\examples{
## input files
demo.dir <- system.file("data", package="cfTools")
readsBinningFile <- file.path(demo.dir, "CancerDetector.reads.txt.gz")
tissueMarkersFile <- file.path(demo.dir, "CancerDetector.markers.txt.gz")
lambda <- 0.5
id <- "test"

CancerDetector(readsBinningFile, tissueMarkersFile, lambda, id)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFractionPie.R
\name{PlotFractionPie}
\alias{PlotFractionPie}
\title{Plot Pie Chart}
\usage{
PlotFractionPie(
  fraction_vector,
  title = "Composition",
  threshold = 0.01,
  class_colors = NULL,
  font_size = 1
)
}
\arguments{
\item{fraction_vector}{a named numeric vector or one-row data.frame, 
where each value represents a class proportion.}

\item{title}{the title of the plot.}

\item{threshold}{a numeric value. Classes with fraction values below this 
threshold will be grouped into "Other".}

\item{class_colors}{a named character vector assigning colors to specific 
class names (e.g., c("tumor" = "red")).}

\item{font_size}{numeric, font scaling factor (default is 1.0).}
}
\value{
A pie chart is plotted to the current device.
}
\description{
Generate a pie chart for a vector of class fractions (e.g., tissue 
composition or cfDNA fractions). Automatically filters small values 
into an "Other" group, and allows for custom colors and font size control.
}
\examples{
df <- data.frame(
  WBC = 0.93,
  Liver = 0.04,
  Lung = 0.02,
  Muscle = 1.2345e-4,
  Stomach = 9.87655e-03
)
PlotFractionPie(df, title = "cfDNA Composition", font_size = 1.2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-cfDeconvolve.markers.R
\name{cfDeconvolve.markers}
\alias{cfDeconvolve.markers}
\title{Tissue-specific marker parameter}
\format{
A tibble with 10 rows and 8 variables
\describe{
\item{markerName}{Name of the marker}
\item{tissue1}{Paired beta distribution shape parameters 
for tissue1 samples}
\item{tissue2}{Paired beta distribution shape parameters 
for tissue2 samples}
\item{tissue3}{Paired beta distribution shape parameters 
for tissue3 samples}
\item{tissue4}{Paired beta distribution shape parameters 
for tissue4 samples}
\item{tissue5}{Paired beta distribution shape parameters 
for tissue5 samples}
\item{tissue6}{Paired beta distribution shape parameters 
for tissue6 samples}
\item{tissue7}{Paired beta distribution shape parameters 
for tissue7 samples}
}
}
\usage{
data("cfDeconvolve.markers")
}
\value{
A tibble with 10 rows and 8 variables
}
\description{
The paired shape parameters of beta distributions 
for tissue-specific markers
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cfTools.R
\docType{package}
\name{cfTools}
\alias{cfTools}
\title{cfTools: a versatile package for analyzing cell-free DNA data}
\description{
Given the methylation sequencing data of a cell-free DNA (cfDNA) sample, 
for each cancer marker or tissue marker, we deconvolve the tumor-derived 
or tissue-specific reads from all reads falling in the marker region. 
Our read-based deconvolution algorithm exploits the pervasiveness of 
DNA methylation for signal enhancement, therefore can sensitively identify 
a trace amount of tumor-specific or tissue-specific cfDNA in plasma.
}
\details{
Specifically, cfTools can deconvolve different sources of 
cfDNA fragments (or reads) in two contexts:

1. Cancer detection: separate cfDNA fragments into tumor-derived 
fragments and background normal fragments (2 classes), and estimate the 
tumor-derived cfDNA fraction.

2. Tissue deconvolution: separate cfDNA fragments from different tissues 
(> 2 classes), and estimate the cfDNA fraction of different tissue types 
(including an unknown type) for a plasma cfDNA sample.

These functions can serve as foundations for more advanced cfDNA-based studies, 
including cancer diagnosis and disease monitoring.

For an overview of the functionality provided by the package, please see the
vignette:
\code{vignette(package="cfTools")}
}
\seealso{
\code{\link{CancerDetector}}, \code{\link{cfDeconvolve}}, 
\code{\link{cfSort}}, \code{\link{MergeCpGs}}, \code{\link{MergePEReads}},
\code{\link{GenerateFragMeth}}, \code{\link{GenerateMarkerParam}}, 
\code{\link{PlotFractionPie}}
}
\author{
Ran Hu \email{huran@ucla.edu}, 
Mary Louisa Stackpole,
Shuo Li,
Xianghong Jasmine Zhou \email{XJZhou@mednet.ucla.edu},
Wenyuan Li \email{WenyuanLi@mednet.ucla.edu}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-markers_index.R
\name{marker_index}
\alias{marker_index}
\title{Marker name}
\format{
A tibble with 3 rows and 1 variables
\describe{
\item{markerIndex}{Marker name}
}
}
\usage{
data("marker_index")
}
\value{
A tibble with 3 rows and 1 variables
}
\description{
A vector of marker names corresponding to the columns 
of the list of methylation levels.
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-demo.refo_frag.bed.R
\name{demo.refo_frag.bed}
\alias{demo.refo_frag.bed}
\title{Fragment-level information}
\format{
A tibble with 559 rows and 6 variables
\describe{
\item{chr}{Chromosome}
\item{start}{Chromosome start}
\item{end}{Chromosome end}
\item{fragmentLength}{Fragment length}
\item{strand}{Strand}
\item{name}{ID of the sequence}
}
}
\usage{
data("demo.refo_frag.bed")
}
\value{
A tibble with 559 rows and 6 variables
}
\description{
A BED file of fragment-level information
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-CpG_OT_demo.R
\name{CpG_OT_demo}
\alias{CpG_OT_demo}
\title{Methylation information for CpG on the original top strand (OT)}
\format{
A tibble with 2556 rows and 5 variables
\describe{
\item{sequence ID}{ID of the sequence}
\item{methylation state}{Methylated or unmethylated CpG site}
\item{chromosome name}{Chromosome name}
\item{chromosome start}{Chromosome start position}
\item{methylation call}{Methylation call}
}
}
\usage{
data("CpG_OT_demo")
}
\value{
A tibble with 2556 rows and 5 variables
}
\description{
Methylation information for CpG on the original 
top strand (OT), which is one of the outputs from 
'bismark methylation extractor'
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-cfsort_markers.R
\name{cfsort_markers}
\alias{cfsort_markers}
\title{cfSort markers}
\format{
A tibble with 51035 rows and 4 variables
\describe{
\item{marker_index}{The marker index used in cfSort method}
\item{alpha_threshold}{The alpha threshold for each marker}
\item{pair}{The pair of tissues used for identifying the marker}
\item{group}{The group number for each marker}
}
}
\usage{
data("cfsort_markers")
}
\value{
A tibble with 51035 rows and 4 variables
}
\description{
Marker information for the cfSort function, 
where each row is the information about a marker
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cfDeconvolve.R
\name{cfDeconvolve}
\alias{cfDeconvolve}
\title{cfDNA methylation read deconvolution}
\usage{
cfDeconvolve(
  readsBinningFile,
  tissueMarkersFile,
  numTissues,
  emAlgorithmType = "em.global.unknown",
  likelihoodRatioThreshold = 2,
  emMaxIterations = 100,
  randomSeed = 0,
  id = "sample"
)
}
\arguments{
\item{readsBinningFile}{a file of the fragment-level methylation states 
of reads that mapped to the markers. Either in plain text or compressed form.}

\item{tissueMarkersFile}{a file of paired shape parameters of beta 
distributions for markers.}

\item{numTissues}{a number of tissue types.}

\item{emAlgorithmType}{a read-based tissue deconvolution EM algorithm type: 
em.global.unknown (default), em.global.known, em.local.unknown, 
em.local.known.}

\item{likelihoodRatioThreshold}{a positive float number. Default is 2.}

\item{emMaxIterations}{a number of EM algorithm maximum iteration. 
Default is 100.}

\item{randomSeed}{a random seed that initialize the EM algorithm. 
Default is 0.}

\item{id}{the sample ID.}
}
\value{
a list containing the cfDNA fractions of different 
tissue types and an unknown class.
}
\description{
Infer the tissue-type composition of plasma cfDNA.
}
\examples{
## input files
demo.dir <- system.file("data", package="cfTools")
readsBinningFile <- file.path(demo.dir, "cfDeconvolve.reads.txt.gz")
tissueMarkersFile <- file.path(demo.dir, "cfDeconvolve.markers.txt.gz")
numTissues <- 7
emAlgorithmType <- "em.global.unknown"
likelihoodRatioThreshold <- 2
emMaxIterations <- 100
randomSeed <- 0
id <- "test"

cfDeconvolve(readsBinningFile, tissueMarkersFile, numTissues, 
emAlgorithmType, likelihoodRatioThreshold, emMaxIterations, randomSeed, id)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-CancerDetector.markers.R
\name{CancerDetector.markers}
\alias{CancerDetector.markers}
\title{Cancer-specific marker parameter}
\format{
A tibble with 1266 rows and 3 variables
\describe{
\item{markerName}{Name of the marker}
\item{tumor}{Paired beta distribution shape parameters 
for tumor samples}
\item{normalPlasma}{Paired beta distribution shape 
parameters for normal plasma samples}
}
}
\usage{
data("CancerDetector.markers")
}
\value{
A tibble with 1266 rows and 3 variables
}
\description{
The paired shape parameters of beta distributions 
for cancer-specific markers
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MergeCpGs.R
\name{MergeCpGs}
\alias{MergeCpGs}
\title{Generate fragment-level methylation states of CpGs}
\usage{
MergeCpGs(CpG_OT, CpG_OB, output.dir = "", id = "")
}
\arguments{
\item{CpG_OT}{a file of methylation information for CpG on the 
original top strand (OT), 
which is one of the outputs from `bismark methylation extractor`.}

\item{CpG_OB}{a file of methylation information for CpG on the 
original bottom strand (OB), 
which is one of the outputs from `bismark methylation extractor`.}

\item{output.dir}{a path to the output directory. Default is "", 
which means the output will not be written into a file.}

\item{id}{an ID name for the input data. Default is "", 
which means the output will not be written into a file.}
}
\value{
a list in BED file format and/or written to 
an output BED file.
}
\description{
Merge the methylation states of all CpGs corresponding to the 
same fragment onto one line in output.
}
\examples{
## input files
demo.dir <- system.file("data", package="cfTools")
CpG_OT <- file.path(demo.dir, "CpG_OT_demo.txt.gz")
CpG_OB <- file.path(demo.dir, "CpG_OB_demo.txt.gz")

output <- MergeCpGs(CpG_OT, CpG_OB)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cfSort.R
\name{cfSort}
\alias{cfSort}
\title{cfSort: tissue deconvolution}
\usage{
cfSort(readsBinningFile, id = "sample")
}
\arguments{
\item{readsBinningFile}{a file of the fragment-level methylation states 
of reads that mapped to the cfSort markers. In compressed form.}

\item{id}{the sample ID.}
}
\value{
the tissue composition of the cfDNA sample.
}
\description{
Tissue deconvolution in cfDNA using DNN models.
}
\examples{
## input files
demo.dir <- system.file("data", package="cfTools")
readsBinningFile <- file.path(demo.dir, "cfsort_reads.txt.gz")
id <- "test"

cfSort(readsBinningFile, id)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-demo.refo_meth.bed.R
\name{demo.refo_meth.bed}
\alias{demo.refo_meth.bed}
\title{Methylation information on fragments}
\format{
A tibble with 552 rows and 8 variables
\describe{
\item{chr}{Chromosome}
\item{cpgStart}{Start postion of first CpG on the fragment}
\item{cpgEnd}{End postion of first CpG on the fragment}
\item{strand}{Strand}
\item{cpgNumber}{Number of CpG sites on the fragment}
\item{cpgPosition}{Postions of CpG sites on the fragment}
\item{methState}{A string of methylation states of 
CpG sites on the fragment}
\item{name}{ID of the sequence}
}
}
\usage{
data("demo.refo_meth.bed")
}
\value{
A tibble with 552 rows and 8 variables
}
\description{
A BED file of methylation information on fragments
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-sample_type.R
\name{sample_type}
\alias{sample_type}
\title{Sample type}
\format{
A tibble with 20 rows and 1 variables
\describe{
\item{sampleType}{Sample type}
}
}
\usage{
data("sample_type")
}
\value{
A tibble with 20 rows and 1 variables
}
\description{
A vector of sample types (e.g., tumor or normal, 
tissue types) corresponding to the rows of the 
list of methylation levels.
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-cfsort_reads.R
\name{cfsort_reads}
\alias{cfsort_reads}
\title{Fragment-level methylation state for cfSort tissue deconvolution}
\format{
A tibble with 99999 rows and 2 variables
\describe{
\item{markerName}{Name of the cfSort marker}
\item{methState}{Fragment-level methylation states, 
which are represented by a sequence of binary values 
(0 represents unmethylated CpG and 1 represents methylated 
CpG on the same fragment)}
}
}
\usage{
data("cfsort_reads")
}
\value{
A tibble with 99999 rows and 2 variables
}
\description{
The fragment-level methylation states of reads that mapped 
to the cfSort markers
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-beta_matrix.R
\name{beta_matrix}
\alias{beta_matrix}
\title{Beta value matrix}
\format{
A tibble with 20 rows and 3 variables
\describe{
\item{marker1}{Beta values of marker1 for all samples}
\item{marker2}{Beta values of marker2 for all samples}
\item{marker3}{Beta values of marker3 for all samples}
}
}
\usage{
data("beta_matrix")
}
\value{
A tibble with 20 rows and 3 variables
}
\description{
A list of methylation levels (e.g., beta values), 
where each row is a sample and each column is a marker
}
\author{
Ran Hu \email{huran@ucla.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenerateFragMeth.R
\name{GenerateFragMeth}
\alias{GenerateFragMeth}
\title{Generate fragment-level information about methylation states}
\usage{
GenerateFragMeth(frag_bed, meth_bed, output.dir = "", id = "")
}
\arguments{
\item{frag_bed}{a BED file containing information for every fragment, 
which is the output of MergePEReads().}

\item{meth_bed}{a BED file containing methylation states on every fragment, 
which is the output of MergeCpGs().}

\item{output.dir}{a path to the output directory. Default is "", 
which means the output will not be written into a file.}

\item{id}{an ID name for the input data. Default is "", 
which means the output will not be written into a file.}
}
\value{
a list in BED file format and/or written to 
an output BED file.
}
\description{
Join two lists containing the fragment information and the 
methylation states on each fragment into one list.
}
\examples{
## input files
demo.dir <- system.file("data", package="cfTools")
frag_bed <- read.delim(file.path(demo.dir, "demo.refo_frag.bed.txt.gz"), 
colClasses = "character")
meth_bed <- read.delim(file.path(demo.dir, "demo.refo_meth.bed.txt.gz"), 
colClasses = "character")

output <- GenerateFragMeth(frag_bed, meth_bed)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data-demo.sorted.bed.R
\name{demo.sorted.bed}
\alias{demo.sorted.bed}
\title{Paired-end sequencing reads}
\format{
A tibble with 1117 rows and 6 variables
\describe{
\item{chr}{Chromosome name}
\item{start}{Chromosome start}
\item{end}{Chromosome end}
\item{name}{Sequence ID}
\item{score}{Mapping quality score}
\item{strand}{Strand}
}
}
\usage{
data("demo.sorted.bed")
}
\value{
A tibble with 1117 rows and 6 variables
}
\description{
Paired-end sequencing reads information
}
\author{
Ran Hu \email{huran@ucla.edu}
}
